/**
******************************************************************************
* @file    			bsp_i2c_gpio.c                                               *
* @author  			WisIOE Software Team                                         *
* @version 			V1.2																												 *		
* @date    			2017-11-01																								   *
* @brief 				I2C GPIOӦúbsp  									   				           *					
******************************************************************************
* @company  		Ƽ޹˾                                         *
* @website  		www.wisioe.com																							 *	 				
* @forum        www.w5500.cn																								 *		
* @qqGroup      383035001																										 * 
******************************************************************************
*/
#include "HAL_device.h"
#include "bsp_i2c_gpio.h"

/* I2CӵGPIO˿, ûֻҪ޸4д뼴ıSCLSDA */
#define GPIO_PORT_I2C	GPIOB		               	/* GPIO˿ */
#define RCC_I2C_PORT 	RCC_APB2Periph_GPIOB		/* GPIO˿ʱ */
#define I2C_SCL_PIN		GPIO_Pin_6			        /* ӵSCLʱߵGPIO */
#define I2C_SDA_PIN		GPIO_Pin_7			        /* ӵSDAߵGPIO */

/* дSCLSDAĺ꣬ӴĿֲԺͿĶ */
#if 0	/* 룺 1 ѡGPIOĿ⺯ʵIOд */
	#define I2C_SCL_1()  GPIO_SetBits(GPIO_PORT_I2C, I2C_SCL_PIN)		  /* SCL = 1 */
	#define I2C_SCL_0()  GPIO_ResetBits(GPIO_PORT_I2C, I2C_SCL_PIN)		/* SCL = 0 */
	 
	#define I2C_SDA_1()  GPIO_SetBits(GPIO_PORT_I2C, I2C_SDA_PIN)		  /* SDA = 1 */
	#define I2C_SDA_0()  GPIO_ResetBits(GPIO_PORT_I2C, I2C_SDA_PIN)		/* SDA = 0 */
	
	#define I2C_SDA_READ()  GPIO_ReadInputDataBit(GPIO_PORT_I2C, I2C_SDA_PIN)	/* SDA״̬ */
#else	/* ֧ѡֱӼĴʵIOд */
      /*ע⣺дIAR߼ŻʱᱻŻ */
	#define I2C_SCL_1()  GPIO_PORT_I2C->BSRR = I2C_SCL_PIN			    	/* SCL = 1 */
	#define I2C_SCL_0()  GPIO_PORT_I2C->BRR = I2C_SCL_PIN				      /* SCL = 0 */
	
	#define I2C_SDA_1()  GPIO_PORT_I2C->BSRR = I2C_SDA_PIN				    /* SDA = 1 */
	#define I2C_SDA_0()  GPIO_PORT_I2C->BRR = I2C_SDA_PIN			      	/* SDA = 0 */
	
	#define I2C_SDA_READ()  ((GPIO_PORT_I2C->IDR & I2C_SDA_PIN) != 0)	/* SDA״̬ */
#endif

 void i2c_CfgGpio(void);

/*
*****************************************************
*	  : i2c_Delay                               *
*	˵: I2Cλӳ٣400KHz               *
*	    Σ                                      *
*	  ֵ:                                       *    
*****************************************************
*/
static void i2c_Delay(void)
{
	uint8_t i;

	/*
	 	ʱͨAX-Pro߼ǲԵõġ
		CPUƵ72MHzʱڲFlash, MDK̲Ż
		ѭΪ10ʱSCLƵ = 205KHz 
		ѭΪ7ʱSCLƵ = 347KHz SCLߵƽʱ1.5usSCL͵ƽʱ2.87us 
	 	ѭΪ5ʱSCLƵ = 421KHz SCLߵƽʱ1.25usSCL͵ƽʱ2.375us 
        
    IAṞЧʸߣΪ7
	*/
	for (i = 0; i < 10; i++);
}

/*
*********************************************************
*	  : i2c_Start																		*
*	˵: CPUI2Cź                      *
*	    Σ                                          *
*	  ֵ:                                           * 
*********************************************************
*/
void i2c_Start(void)
{
	/* SCLߵƽʱSDAһرʾI2Cź */
	I2C_SDA_1();
	I2C_SCL_1();
	i2c_Delay();
	I2C_SDA_0();
	i2c_Delay();
	I2C_SCL_0();
	i2c_Delay();
}

/*
*********************************************************
*	  : i2c_Start																		*		
*	˵: CPUI2Cֹͣź                      *
*	    Σ                                          *  
*	  ֵ:                                           *   
*********************************************************
*/
void i2c_Stop(void)
{
	/* SCLߵƽʱSDAһرʾI2Cֹͣź */
	I2C_SDA_0();
	I2C_SCL_1();
	i2c_Delay();
	I2C_SDA_1();
}

/*
*********************************************************
*	  : i2c_SendByte                                *
*	˵: CPUI2C豸8bit                *  
*	    Σ_ucByte  ȴ͵ֽ                   *
*	  ֵ:                                           *
*********************************************************
*/
void i2c_SendByte(uint8_t _ucByte)
{
	uint8_t i;

	/* ȷֽڵĸλbit7 */
	for (i = 0; i < 8; i++)
	{		
		if (_ucByte & 0x80)
		{
			I2C_SDA_1();
		}
		else
		{
			I2C_SDA_0();
		}
		i2c_Delay();
		I2C_SCL_1();
		i2c_Delay();	
		I2C_SCL_0();
		if (i == 7)
		{
			 I2C_SDA_1(); /* ͷ */
		}
		_ucByte <<= 1;	/* һbit */
		i2c_Delay();
	}
}

/*
***************************************************
*	  : i2c_ReadByte													*
*	˵: CPUI2C豸ȡ8bit				  * 
*	    Σ                                    *
*	  ֵ:                             *  
***************************************************
*/
uint8_t i2c_ReadByte(void)
{
	uint8_t i;
	uint8_t value;

	/* 1bitΪݵbit7 */
	value = 0;
	for (i = 0; i < 8; i++)
	{
		value <<= 1;
		I2C_SCL_1();
		i2c_Delay();
		if (I2C_SDA_READ())
		{
			value++;
		}
		I2C_SCL_0();
		i2c_Delay();
	}
	return value;
}

/*
*****************************************************************
*	  : i2c_WaitAck																					*
*	˵: CPUһʱӣȡACKӦź            *
*	    Σ                                                  * 
*	  ֵ: 0ʾȷӦ1ʾӦ                  *
*****************************************************************
*/
uint8_t i2c_WaitAck(void)
{
	uint8_t re;

	I2C_SDA_1();	      /* CPUͷSDA */
	i2c_Delay();
	I2C_SCL_1();	      /* CPUSCL = 1, ʱ᷵ACKӦ */
	i2c_Delay();
	if (I2C_SDA_READ())	/* CPUȡSDA״̬ */
	{
		re = 1;
	}
	else
	{
		re = 0;
	}
	I2C_SCL_0();
	i2c_Delay();
	return re;
}

/*
************************************************
*	  : i2c_Ack											       *  
*	˵: CPUһACKź                 *
*	    Σ                                 * 
*	  ֵ:                                  *
************************************************
*/
void i2c_Ack(void)
{
	I2C_SDA_0();	/* CPUSDA = 0 */
	i2c_Delay();
	I2C_SCL_1();	/* CPU1ʱ */
	i2c_Delay();
	I2C_SCL_0();
	i2c_Delay();
	I2C_SDA_1();	/* CPUͷSDA */
}

/*
*************************************************
*	  : i2c_NAck                            *
*	˵: CPU1NACKź                  * 
*	    Σ                                  *
*	  ֵ:                                   * 
*************************************************
*/
void i2c_NAck(void)
{
	I2C_SDA_1();	/* CPUSDA = 1 */
	i2c_Delay();
	I2C_SCL_1();	/* CPU1ʱ */
	i2c_Delay();
	I2C_SCL_0();
	i2c_Delay();	
}

/*
*************************************************************
*	  : i2c_CfgGpio																			*	
*	˵: I2CߵGPIOģIOķʽʵ					*
*	    Σ																							*
*	  ֵ: 																							*				
*************************************************************
*/
void i2c_CfgGpio(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_I2C_PORT, ENABLE);	      /* GPIOʱ */

	GPIO_InitStructure.GPIO_Pin = I2C_SCL_PIN | I2C_SDA_PIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;  	/* © */
	GPIO_Init(GPIO_PORT_I2C, &GPIO_InitStructure);

	/* һֹͣź, λI2Cϵ豸ģʽ */
	i2c_Stop();
}

/*
*******************************************************************************************
*	  : i2c_CheckDevice                                                               *
*	˵: I2C豸CPU豸ַȻȡ豸Ӧжϸ豸Ƿ			*	
*	    Σ_Address豸I2Cߵַ																										*				
*	  ֵ: ֵ 0 ʾȷ 1ʾδ̽⵽																					*			
*******************************************************************************************
*/
uint8_t i2c_CheckDevice(uint8_t _Address)
{
	uint8_t ucAck;

	i2c_CfgGpio();		      /* GPIO */

	
	i2c_Start();		        /* ź */

	/* 豸ַ+дbit0 = w 1 = r) bit7 ȴ */
	i2c_SendByte(_Address | I2C_WR);
	ucAck = i2c_WaitAck();	/* 豸ACKӦ */

	i2c_Stop();			        /* ֹͣź */

	return ucAck;
}
